/**!
 * Sparticles - Lightweight, High Performance Particles in Canvas
 * @version 1.0.0
 * @license MPL-2.0
 * @author simeydotme <simey.me@gmail.com>
 * @website http://sparticlesjs.dev
 * @repository https://github.com/simeydotme/sparticles.git
 */
var Sparticles=function(){"use strict";function t(t,e,i){return e in t?Object.defineProperty(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t}function e(t,e){var i=Object.keys(t);if(Object.getOwnPropertySymbols){var s=Object.getOwnPropertySymbols(t);e&&(s=s.filter((function(e){return Object.getOwnPropertyDescriptor(t,e).enumerable}))),i.push.apply(i,s)}return i}function i(i){for(var s=1;s<arguments.length;s++){var r=null!=arguments[s]?arguments[s]:{};s%2?e(r,!0).forEach((function(e){t(i,e,r[e])})):Object.getOwnPropertyDescriptors?Object.defineProperties(i,Object.getOwnPropertyDescriptors(r)):e(r).forEach((function(t){Object.defineProperty(i,t,Object.getOwnPropertyDescriptor(r,t))}))}return i}var s=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){},e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:60;this.fps=e,this.handler=t;var i=0;this.start=function(){var t=this;if(!this.started){var e=performance.now(),s=1e3/this.fps;i=requestAnimationFrame((function r(n){var a=n-e;i=requestAnimationFrame(r),a>=s-0&&(t.handler(a),e=n-a%s)})),this.started=!0}},this.stop=function(){cancelAnimationFrame(i),this.started=!1}},r=function(t){return[Math.cos(a(t-90)),Math.sin(a(t-90))]},n=function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:0,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:1;return Math.max(e,Math.min(i,t))},a=function(t){return t*Math.PI/180},h=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:Math.random();return e<=t?i=t:(0!==t||1!==e)&&e>t&&(i=i*(e-t)+t),i},o=function(t){return t[Math.floor(h(0,t.length))]},c=function(){var t=p(h(0,360)),e=p(h(90,100)),i=p(h(45,85));return"hsl(".concat(t,",").concat(e,"%,").concat(i,"%)")},l=function(t){return t>h()},p=function(t){return.5+t|0},d=function(t){return t?(this.canvas=t.canvas,this.images=t.images,this.settings=t.settings,this.ctx=t.canvas.getContext("2d"),this.setup(),this.init()):console.warn("Invalid parameters given to Sparticle()",arguments),this};d.prototype.setup=function(){var t=this.settings;this.frame=0,this.frameoffset=p(h(0,360)),this.size=p(h(t.minSize,t.maxSize)),this.da=this.getAlphaDelta(),this.dx=this.getDeltaX(),this.dy=this.getDeltaY(),this.dd=this.getDriftDelta(),this.dr=this.getRotationDelta(),this.shape=this.getShapeOrImage(),this.style=this.getStyle(),this.color=this.getColor(),this.rotation=t.rotate?a(h(0,360)):0,this.vertical=t.direction>150&&t.direction<210||t.direction>330&&t.direction<390||t.direction>-30&&t.direction<30,this.horizontal=t.direction>60&&t.direction<120||t.direction>240&&t.direction<300},d.prototype.init=function(){var t=this.settings,e=this.canvas;this.alpha=0,(t.speed>0||0===t.alphaSpeed)&&(this.alpha=h(t.minAlpha,t.maxAlpha)),t.bounce?(this.px=p(h(2,e.width-this.size-2)),this.py=p(h(2,e.height-this.size-2))):(this.px=p(h(2*-this.size,e.width+this.size)),this.py=p(h(2*-this.size,e.height+this.size)))},d.prototype.reset=function(){this.setup(),this.py<0?this.py=this.canvas.height+2*this.size:this.py>this.canvas.height&&(this.py=0-2*this.size),this.px<0?this.px=this.canvas.width+2*this.size:this.px>this.canvas.width&&(this.px=0-2*this.size)},d.prototype.bounce=function(){this.settings.direction;(this.py<=0||this.py+this.size>=this.canvas.height)&&(this.dy=-this.dy,this.horizontal&&(this.dd=-this.dd)),(this.px<=0||this.px+this.size>=this.canvas.width)&&(this.dx=-this.dx,this.vertical&&(this.dd=-this.dd))},d.prototype.isOffCanvas=function(){var t=0-2*this.size,e=this.canvas.height+2*this.size,i=this.canvas.width+2*this.size;return this.px<t||this.px>i||this.py<t||this.py>e},d.prototype.isTouchingEdge=function(){var t=this.canvas.height-this.size,e=this.canvas.width-this.size;return this.px<0||this.px>e||this.py<0||this.py>t},d.prototype.getColor=function(){if(Array.isArray(this.settings.color))return o(this.settings.color)},d.prototype.getShapeOrImage=function(){var t=this.settings.shape;if(Array.isArray(t))return"image"===t[0]&&this.images?o(this.images):o(t)},d.prototype.getStyle=function(){return o(this.settings.style)},d.prototype.getDelta=function(){var t=.1*this.settings.speed;return this.settings.speed&&this.settings.parallax?t+this.size*this.settings.parallax/50:t},d.prototype.getDeltaVariance=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,e=this.settings.speed||10;return t>0?h(-t,t)*e/100:0},d.prototype.getDeltaX=function(){var t=this.getDelta(),e=this.getDeltaVariance(this.settings.xVariance);return r(this.settings.direction)[0]*t+e},d.prototype.getDeltaY=function(){var t=this.getDelta(),e=this.getDeltaVariance(this.settings.yVariance);return r(this.settings.direction)[1]*t+e},d.prototype.getAlphaDelta=function(){var t=this.settings.alphaVariance,e=h(1,t+1);return l(.5)&&(e=-e),e},d.prototype.getDriftDelta=function(){return this.settings.drift?h(this.settings.drift-this.settings.drift/2,this.settings.drift+this.settings.drift/2):0},d.prototype.getRotationDelta=function(){var t=0;return this.settings.rotate&&this.settings.rotation&&(t=a(h(.5,1.5)*this.settings.rotation),l(.5)&&(t=-t)),t},d.prototype.update=function(){return this.frame+=1,this.updatePosition(),this.updateAlpha(),this},d.prototype.updateAlpha=function(){return this.settings.alphaSpeed>0&&(this.settings.twinkle?this.alpha=this.updateTwinkle():this.alpha=this.updateFade()),this.alpha},d.prototype.updateFade=function(){var t=this.da/1e3*this.settings.alphaSpeed*.5,e=this.alpha+t,i=this.da>0&&e>this.settings.maxAlpha,s=this.da<0&&e<this.settings.minAlpha;return(i||s)&&(this.da=-this.da,e=this.settings.maxAlpha,s&&(e=this.settings.minAlpha)),e},d.prototype.updateTwinkle=function(){var t=this.alpha,e=Math.abs(this.da),i=t>this.settings.maxAlpha,s=t<this.settings.minAlpha,r=e/1e3*this.settings.alphaSpeed*.5,n=l(1/30),a=l(1/30);return this.resettingTwinkle?t+=5*r:n?t+=50*r:t-=a?25*r:r,s?(this.resettingTwinkle=!0,t=this.settings.minAlpha):i&&(this.resettingTwinkle=!1,t=this.settings.maxAlpha),t},d.prototype.updatePosition=function(){if(this.settings.bounce&&this.isTouchingEdge())this.bounce();else if(this.isOffCanvas())return void this.reset();this.px+=this.dx,this.py+=this.dy,this.updateDrift(),this.updateRotation()},d.prototype.updateRotation=function(){this.settings.rotate&&this.settings.rotation&&(this.rotation+=this.dr)},d.prototype.updateDrift=function(){var t=this.settings;t.direction;t.drift&&t.speed&&(this.vertical?this.px+=r(this.frame+this.frameoffset)[0]*this.dd/(15*this.getDelta()):this.horizontal&&(this.py+=r(this.frame+this.frameoffset)[1]*this.dd/(15*this.getDelta())))},d.prototype.render=function(t){var e=t[this.color][this.shape];"image"!==this.settings.shape[0]&&(e=t[this.color][this.shape][this.style]);var i=e.width,s=this.size/i,r=this.px/s,a=this.py/s;return this.ctx.globalAlpha=n(this.alpha,0,1),this.renderRotate(),this.ctx.transform(s,0,0,s,0,0),this.ctx.drawImage(e,0,0,i,i,r,a,i,i),this.ctx.setTransform(1,0,0,1,0,0),this},d.prototype.renderRotate=function(){if("circle"!==this.shape&&this.settings.rotate){var t=this.px+this.size/2,e=this.py+this.size/2;this.ctx.translate(t,e),this.ctx.rotate(this.rotation),this.ctx.translate(-t,-e)}};var u=function(t,e,r,n){arguments.length>=1&&!(arguments[0]instanceof HTMLElement)&&(e=arguments[0],r=arguments[1],n=arguments[2],t=void 0),r&&!n&&(n=r);var a={alphaSpeed:10,alphaVariance:1,bounce:!1,color:"random",randomColor:c,randomColorCount:3,composition:"source-over",count:50,direction:180,drift:1,glow:0,imageUrl:"",maxAlpha:1,maxSize:10,minAlpha:0,minSize:1,parallax:1,rotate:!0,rotation:1,shape:"circle",speed:10,style:"fill",twinkle:!1,xVariance:2,yVariance:2};return this.el=t||document.body,this.settings=i({},a,{},e),this.resizable=!r&&!n,this.width=this.resizable?this.el.clientWidth:r,this.height=this.resizable?this.el.clientHeight:n,this.init=function(){var t=this;return this.sparticles=[],this.createColorArray(),this.createShapeArray(),this.createStyleArray(),this.setupMainCanvas(),this.setupOffscreenCanvasses((function(){t.createSparticles(),t.start()})),window.addEventListener("resize",this),this},this.handleEvent=function(t){var e=this;"resize"===t.type&&(clearTimeout(this.resizeTimer),this.resizeTimer=setTimeout((function(){e.resizable&&(e.width=e.el.clientWidth,e.height=e.el.clientHeight,e.setCanvasSize().resetSparticles())}),200))},this.start=function(){var t=this;return this.loop||(this.loop=new s((function(e){t.drawFrame(e)}))),this.loop.start(),this},this.stop=function(){return this.loop.stop(),this},this.destroy=function(){for(var t in this.stop(),this.el.removeChild(this.canvas),window.removeEventListener("resize",this),this)this.hasOwnProperty(t)&&delete this[t];return this},this.setCanvasSize=function(t,e){return t&&(this.resizable=!1),this.width=t||this.width,this.height=e||this.height,this.canvas.width=this.width,this.canvas.height=this.height,this},this.resetSparticles=this.createSparticles=function(){this.sparticles=[],this.ctx.globalCompositeOperation=this.settings.composition;for(var t=0;t<this.settings.count;t++)this.sparticles.push(new d(this));return this.sparticles.sort((function(t,e){return t.size>e.size})),this.sparticles},this.init()};return u.prototype.createColorArray=function(){var t=this.settings;if(Array.isArray(t.color)||(t.color=[t.color]),t.color.some((function(t){return"random"===t})))for(var e=0;e<t.randomColorCount;e++)t.color[e]=t.randomColor(e,t.randomColorCount);return t.color},u.prototype.createShapeArray=function(){var t=this.settings;return Array.isArray(t.shape)||(t.shape=[t.shape]),t.shape.some((function(t){return"random"===t}))&&(t.shape=["square","circle","star","diamond"]),t.shape},u.prototype.createStyleArray=function(){return"fill"!==this.settings.style&&"stroke"!==this.settings.style?this.settings.style=["fill","stroke"]:this.settings.style=[this.settings.style],this.settings.style},u.prototype.setupMainCanvas=function(){return this.canvas=document.createElement("canvas"),this.canvas.setAttribute("class","sparticles"),this.ctx=this.canvas.getContext("2d"),this.setCanvasSize(),this.el.appendChild(this.canvas),this.canvas},u.prototype.setupOffscreenCanvasses=function(t){var e=this;this.canvasses=this.canvasses||{},this.settings.color.forEach((function(i){e.canvasses[i]=e.canvasses[i]||{},"image"===e.settings.shape[0]?e.loadAndDrawImages(i,t):e.settings.shape.forEach((function(s){e.canvasses[i][s]=e.canvasses[i][s]||{},e.settings.style.forEach((function(r){e.canvasses[i][s][r]=document.createElement("canvas");var n=e.canvasses[i][s][r],a=n.getContext("2d");switch(s){case"square":e.drawOffscreenCanvasForSquare(n,a,i,r),t&&t();break;case"line":e.drawOffscreenCanvasForLine(n,a,i,r),t&&t();break;case"triangle":e.drawOffscreenCanvasForTriangle(n,a,i,r),t&&t();break;case"diamond":e.drawOffscreenCanvasForDiamond(n,a,i,r),t&&t();break;case"star":e.drawOffscreenCanvasForStar(n,a,i,r),t&&t();break;case"circle":default:e.drawOffscreenCanvasForCircle(n,a,i,r),t&&t()}}))}))}))},u.prototype.getGlowSize=function(t){return this.settings.glow},u.prototype.getLineSize=function(t){return n(t/20,1,5)},u.prototype.renderStyle=function(t,e,i,s){"fill"===s?t.fillStyle=e:(t.lineWidth=i,t.strokeStyle=e)},u.prototype.renderGlow=function(t,e,i){var s=this.getGlowSize(i)/2;t.shadowColor=e,t.shadowBlur=s},u.prototype.renderColor=function(t,e){"fill"===e?t.fill():t.stroke()},u.prototype.drawOffscreenCanvasForSquare=function(t,e,i,s){var r=this.settings.maxSize,n=this.getLineSize(r),a=r+n+this.getGlowSize(r);return t.width=a,t.height=a,this.renderGlow(e,i,r),this.renderStyle(e,i,n,s),e.beginPath(),e.rect(a/2-r/2,a/2-r/2,r,r),this.renderColor(e,s),t},u.prototype.drawOffscreenCanvasForLine=function(t,e,i,s){var r=2*this.settings.maxSize,n=this.getLineSize(r),a=r+n+this.getGlowSize(r),h=a/2-r/2,o=a/2-r/2;return t.width=a,t.height=a,this.renderGlow(e,i,r),e.lineWidth=n,e.strokeStyle=i,e.beginPath(),e.moveTo(h,o),e.lineTo(h+r,o+r),e.stroke(),e.closePath(),t},u.prototype.drawOffscreenCanvasForTriangle=function(t,e,i,s){var r=this.settings.maxSize,n=this.getLineSize(r),a=r+n+this.getGlowSize(r),h=r*(Math.sqrt(3)/2),o=a/2,c=a/2-r/2;return t.width=a,t.height=a,this.renderGlow(e,i,r),this.renderStyle(e,i,n,s),e.beginPath(),e.moveTo(o,c),e.lineTo(o-r/2,c+h),e.lineTo(o+r/2,c+h),e.closePath(),this.renderColor(e,s),t},u.prototype.drawOffscreenCanvasForDiamond=function(t,e,i,s){var r=this.settings.maxSize,n=r/2,a=this.getLineSize(r),h=r+a+this.getGlowSize(r),o=h/2,c=.08*r,l=.02*r,p=o-n,d=o;return t.width=h,t.height=h,this.renderGlow(e,i,r),this.renderStyle(e,i,a,s),e.beginPath(),e.moveTo(p+l,d),e.bezierCurveTo(o-c/2,o-2*c,o-2*c,o-c/2,o,o-n),e.bezierCurveTo(o+2*c,o-c/2,o+c/2,o-2*c,o+n-l,o),e.bezierCurveTo(o+c/2,o+2*c,o+2*c,o+c/2,o,o+n),e.bezierCurveTo(o-2*c,o+c/2,o-c/2,o+2*c,p+l,d),e.closePath(),this.renderColor(e,s),t},u.prototype.drawOffscreenCanvasForStar=function(t,e,i,s){var r=this.getLineSize(52),n=this.getGlowSize(52),a=52+2*r+n;return t.width=a,t.height=a,this.renderGlow(e,i,52),this.renderStyle(e,i,r,s),e.translate(r/2+n/2,r/2+n/2-1),e.beginPath(),e.moveTo(27.76,2.07),e.lineTo(34.28,15.46),e.translate(36.01480792437574,14.614221385040288),e.arc(0,0,1.93,2.687967128721911,1.7293919056045395,1),e.translate(-36.01480792437574,-14.614221385040288),e.lineTo(50.37,18.7),e.translate(50.10443046629834,20.601544851632347),e.arc(0,0,1.92,-1.4320339785975214,.8159284165499665,0),e.translate(-50.10443046629834,-20.601544851632347),e.lineTo(40.78,32.36),e.translate(42.13415324373887,33.735197801216785),e.arc(0,0,1.93,-2.3484841809999386,-3.3054346524687857,1),e.translate(-42.13415324373887,-33.735197801216785),e.lineTo(42.7,48.76),e.translate(40.81489078457234,49.06734873663269),e.arc(0,0,1.91,-.16161824093711977,2.052504457600845,0),e.translate(-40.81489078457234,-49.06734873663269),e.lineTo(26.83,43.76),e.translate(25.939999999999998,45.438660180024534),e.arc(0,0,1.9,-1.083293536758034,-2.0582991168317593,1),e.translate(-25.939999999999998,-45.438660180024534),e.lineTo(11.92,50.7),e.translate(11.046023488962076,49.00168758523234),e.arc(0,0,1.91,1.0955254432622383,3.3002085355055915,0),e.translate(-11.046023488962076,-49.00168758523234),e.lineTo(11.7,34),e.translate(9.820265754085725,33.66132734870218),e.arc(0,0,1.91,.178258078542773,-.7933922953534395,1),e.translate(-9.820265754085725,-33.66132734870218),e.lineTo(.57,21.85),e.translate(1.9278161466350117,20.478418681981545),e.arc(0,0,1.93,2.351151232528948,4.5627030955491055,0),e.translate(-1.9278161466350117,-20.478418681981545),e.lineTo(16.31,16.47),e.translate(16.062056630005188,14.576161547207466),e.arc(0,0,1.91,1.4406156600933306,.4870016654036473,1),e.translate(-16.062056630005188,-14.576161547207466),e.lineTo(24.33,2.07),e.translate(26.045,2.9107585860400085),e.arc(0,0,1.91,-2.6857849028374465,-.45580775075234703,0),e.translate(-26.045,-2.9107585860400085),e.closePath(),this.renderColor(e,s),t},u.prototype.drawOffscreenCanvasForCircle=function(t,e,i,s){var r=this.settings.maxSize,n=this.getLineSize(r),a=r+n+this.getGlowSize(r);return t.width=a,t.height=a,this.renderGlow(e,i,r),this.renderStyle(e,i,n,s),e.beginPath(),e.ellipse(a/2,a/2,r/2,r/2,0,0,360),this.renderColor(e,s),t},u.prototype.loadAndDrawImages=function(t,e){var i=this,s=this.settings.imageUrl,r=Array.isArray(s)?s:[s],n=r.length,a=0;this.images=[],r.forEach((function(s,r){i.images.push("image"+r),i.canvasses[t]["image"+r]=document.createElement("canvas");var h=i.canvasses[t]["image"+r],o=h.getContext("2d"),c=new Image;c.onload=function(){a++,i.drawImageOffscreenCanvas(c,h,o,t),e&&a===n&&e()},c.onerror=function(){console.error("failed to load source image: ",s)},c.src=s}))},u.prototype.drawImageOffscreenCanvas=function(t,e,i,s){var r=t.width;return e.width=r,e.height=r,i.drawImage(t,0,0,r,r,0,0,r,r),i.globalCompositeOperation="source-atop",i.fillStyle=s,i.fillRect(0,0,r,r),e},u.prototype.drawFrame=function(){this.ctx.clearRect(0,0,this.width,this.height);for(var t=0;t<this.sparticles.length;t++){this.sparticles[t].update().render(this.canvasses)}return this.sparticles},u}();
